$pscppath1 = "C:\Program Files\Zerto\Zerto Virtual Replication\pscp.exe"
$pscppath2 = "D:\Program Files\Zerto\Zerto Virtual Replication\pscp.exe"
$pscppath3 = "E:\Program Files\Zerto\Zerto Virtual Replication\pscp.exe"

if (Test-Path "$pscppath1")
{
    $pscpPath = $pscppath1
}
elseif (Test-path "$pscppath2")
{
    $pscpPath = $pscppath2
}
elseif (Test-path "$pscppath3")
{
    $pscpPath = $pscppath3
}
else {
    Write-Host "Couldn't find pscp.exe at drives C,D, and E."
}

$plinkpath1 = "C:\Program Files\Zerto\Zerto Virtual Replication\plink.exe"
$plinkpath2 = "D:\Program Files\Zerto\Zerto Virtual Replication\plink.exe"
$plinkpath3 = "E:\Program Files\Zerto\Zerto Virtual Replication\plink.exe"

if (Test-Path "$plinkpath1")
{
    $plinkPath = $plinkpath1
}
elseif (Test-path "$plinkpath2")
{
    $plinkPath = $plinkpath2
}
elseif (Test-path "$plinkpath3")
{
    $plinkPath = $plinkpath3
}
else {
    Write-Host "Couldn't find plink.exe at drives C,D, and E."
}

$keypath1 = "C:\Program Files\Zerto\Zerto Virtual Replication\Secrets\ssh.ppk"
$keypath2 = "D:\Program Files\Zerto\Zerto Virtual Replication\Secrets\ssh.ppk"
$keypath3 = "E:\Program Files\Zerto\Zerto Virtual Replication\Secrets\ssh.ppk"

if (Test-Path "$keypath1")
{
    $keyPath = $keyPath1
}
elseif (Test-path "$keyPath2")
{
    $keyPath = $keyPath2
}
elseif (Test-path "$keyPath3")
{
    $keyPath = $keyPath3
}
else {
    Write-Host "Couldn't find ssh.ppk at drives C,D, and E."
}
if (Test-Path IPs.txt)
{
    $Hours = Read-Host "Number of hours to collect?"
    New-Item -Path . -Type Directory -Name Vralogs
    $PrintVRAs=Get-Content -Path .\IPs.txt
    ForEach($VRA in $PrintVRAs)
    {
    echo y | & $plinkPath -i $keyPath root@"$VRA" "/mnt/run/scripts/collectLogs.sh "$Hours" > /dev/null 2>&1"
    & $pscpPath  -i $keyPath root@"$VRA":/mnt/logs/logsCollection.tar.gz Vralogs\$VRA.tar.gz
    & $plinkPath -i $keyPath root@"$VRA" "rm /mnt/logs/logsCollection.tar.gz"
    }
    Compress-Archive .\Vralogs\ Vralogs
}
else {
$ZVM = "localhost"
$strZVMPort = "9669"
$strZVMUser = Read-Host "Enter your User"
$Password = Read-Host "Enter your Password" -AsSecureString
$strZVMPwd = $password
$BSTR = [System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($Password)
$strZVMPwd = [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR)
################################################
#-Certificates That are not trusted need to be accepted
add-type @"
using System.Net;
using System.Security.Cryptography.X509Certificates;
public class TrustAllCertsPolicy : ICertificatePolicy {
public bool CheckValidationResult(
ServicePoint srvPoint, X509Certificate certificate,
WebRequest request, int certificateProblem) {
return true;
}
}
"@
##### 
# General variables
####
$contentType = "application/json"



##############
[System.Net.ServicePointManager]::CertificatePolicy = New-Object TrustAllCertsPolicy
$requestURLs = @{License = "/v1/license"; AddSession = "/v1/session/add"; PairingToken = "/v1/peersites/generatetoken" ;
Pair = "/v1/peersites"; InstallVra = "/v1/vras"; SiteId = "/v1/virtualizationsites"; VPGCall = "/v1/vpgSettings"}
function Get-Url($ZVM , $Request){
    $URL = "https://" + $ZVM + ":" + $strZVMPort + $requestURLs[$Request]
    return $URL
}
function getxZertoSession ($userName, $password, $ZVM){
    $baseURL = "https://" + $ZVM + ":"+$strZVMPort
    $xZertoSessionURL = $baseURL +"/v1/session/add"
    $authInfo = ("{0}:{1}" -f $userName,$password)
    $authInfo = [System.Text.Encoding]::UTF8.GetBytes($authInfo)
    $authInfo = [System.Convert]::ToBase64String($authInfo)
    $headers = @{Authorization=("Basic {0}" -f $authInfo)}
    $contentType = "application/json"
    $xZertoSessionResponse = Invoke-WebRequest -Uri $xZertoSessionURL -Headers $headers -Method POST -Body $body -ContentType $contentType
    #$xZertoSessionResponse = Invoke-WebRequest -Uri $xZertoSessionURL -Headers $headers -Body $body -Method POST
    return $xZertoSessionResponse.headers.get_item("x-zerto-session")
}
#Extract x-zerto-session from the response, and add it to the actual API:

### Zerto session 132
$xZertoSession132 = getxZertoSession $strZVMUser $strZVMPwd $ZVM
$zertoSessionHeader132 = @{"x-zerto-session"=$xZertoSession132}
$zertoSessionHeader_xml132 = @{"Accept"="application/xml"
"x-zerto-session"=$xZertoSession132}


function GetVRAs{
    $baseURL = "https://" + $ZVM + ":" + $strZVMPort
    $LicenceURL = $baseURL + "/v1/vras"
    $contentType = "application/json"
    Invoke-WebRequest -Uri $LicenceURL -Method Get -Headers $zertoSessionHeader132 -ContentType $contentType
}

$VRAs = GetVRAs | ConvertFrom-Json
$VRAs.Ipaddress | Out-File VRAsIPAddresses.txt

$Hours = Read-Host "Number of hours to collect?"
New-Item -Path . -Type Directory -Name Vralogs
$PrintVRAs=Get-Content -Path .\VRAsIPAddresses.txt
ForEach($VRA in $PrintVRAs)
{
echo y | & $plinkPath -i $keyPath root@"$VRA" "/mnt/run/scripts/collectLogs.sh "$Hours" > /dev/null 2>&1"
& $pscpPath  -i $keyPath root@"$VRA":/mnt/logs/logsCollection.tar.gz Vralogs\$VRA.tar.gz
& $plinkPath -i $keyPath root@"$VRA" "rm /mnt/logs/logsCollection.tar.gz"
}
Compress-Archive .\Vralogs\ Vralogs
}